import java.util.*;
import java.text.*;
/**
*   .    .<br><br>
*
*     {@link #caseBlock(int p_Event)}, 
* {@link #stateChanged(int p_intOldState)},    
*  {@link #m_strStateNames}, {@link #m_strEventNames}, 
* {@link #m_strActionNames}, {@link #m_strVarNames}.
*/
public abstract class BaseAutomata implements Runnable
{
    /** .*/
    protected Context   ctx;    
    
    /**,   */
    private String m_strCaller = null;

    /**   */
    private boolean m_blnProcessingStarted = false;
    
    /**
    *   .<br>
    * <b>Note:</b>     . 
    */
    protected String[]  m_strStateNames;    
    
    /**
    *   .<br>
    * <b>Note:</b>     . 
    */
    protected String[]  m_strEventNames;    
    
    /**
    *   .<br>
    * <b>Note:</b>     . 
    */
    protected String[]  m_strActionNames;   
    
    /**
    *   .<br>
    * <b>Note:</b>     . 
    */
    protected String[]  m_strVarNames;      
    
    /**     .*/
    protected String    m_strName;          
    
    /**
    *     .<br>
    * <b>Note:</b>     . 
    */
    protected int       m_intDelay;         

    /**  .*/
    protected int       y;                  

    /**   .*/
    private Vector      m_events;           
    
    /** .        .*/
    private Thread      m_threadGo;         

    /** " ".*/
    private String      m_strEventFired;

    /** "  ".*/
    private String      m_strStartProcess;

    /** "  ".*/
    private String      m_strEndProcess;
    
    /** " ".*/
    private String      m_strCurrState;

    /** " ".*/
    private String      m_strNewState;

    /** " ".*/
    private String      m_strZ;

    /** " ".*/
    private String      m_strX;

    /** "".*/
    private String      m_strTrue;

    /** "".*/
    private String      m_strFalse;
    
    /**
    * 
    * @param p_strName   .
    * @param p_ctx      .
    */
    public BaseAutomata(String p_strName, Context p_ctx)
    {
        ctx = p_ctx;
        m_strName = p_strName;
        m_events = new Vector();


        m_strEventFired     = ctx.getParameter("EventFired_{0}.{1}");
        m_strStartProcess   = ctx.getParameter("StartProcess_{0}.{1}");
        m_strCurrState      = ctx.getParameter("CurrState_{0}.{1}");    
        m_strZ              = ctx.getParameter("Z_{0}.{1}");    
        m_strNewState       = ctx.getParameter("NewState_{0}.{1}");
        m_strEndProcess     = ctx.getParameter("EndProcess_{0}.{1}");
        m_strX              = ctx.getParameter("X_{0}.{1}.{2}");
        m_strTrue           = ctx.getParameter("TrueName");
        m_strFalse          = ctx.getParameter("FalseName");
            
        y = 0;
    }

    
    /**
    *     .
    * @param p_Event    .
    */
    public void A(BaseEvent p_Event)
    {
        ctx.getLogger(getName()).log(MessageFormat.format(m_strEventFired, new Object[] {new Integer(p_Event.getEvent()), m_strEventNames[p_Event.getEvent()]}), getName(), 0);
        synchronized(m_events)
        {
            m_events.addElement(p_Event);
            if (m_threadGo == null) start();
        }
    }

    /**
    *  .       ,  
    * "" ({@link #stop()}).   - ,   
    *   ({@link #start()}).
    */
    private void start()
    {
        m_threadGo = new Thread(this);
        m_threadGo.start();
    }


    /**
    *   .       , 
    *  * "" ({@link #stop()}).   - ,  
    *  *   ({@link #start()}).
    */
    private void stop()
    {
        m_threadGo = null;
    }

    /**
    *  {@link #caseBlock(int p_Event)} -    
    *  .    - .
    */
    public void run()
    {
	    Thread th = Thread.currentThread();
	    boolean isEvent = false;
	    BaseEvent event = null;
	
	    while (th == m_threadGo)
	    {
	        isEvent = false;
	        event = null;
	        
	
	        //   
	        synchronized(m_events)
	        {
	            if (!m_events.isEmpty())
	            {
	                event = (BaseEvent)m_events.firstElement();
	                m_events.remove(0);
	                isEvent = true;
	            } 
	            else
	            {
	                //    -  ,  
	                //      A(int e)
	                stop();
	            }
	        } 
	        // 
	
	        
	        if (isEvent) 
	        {
	            int intOldState = y;
	            ctx.getLogger(getName()).log(MessageFormat.format(m_strStartProcess, new Object[] {new Integer(event.getEvent()), m_strEventNames[event.getEvent()]}), getName(), 0);
	            ctx.getLogger(getName()).log(MessageFormat.format(m_strCurrState, new Object[] {new Integer(y), m_strStateNames[y]}), getName(), 0);
	            m_strCaller = event.getCaller();
	            m_blnProcessingStarted = true;
	           	try
				{
	        	    caseBlock(event.getEvent());
	        	}
	        	catch (Exception e)
	     		{
	     			e.printStackTrace();
	     			ctx.getLogger(getName()).log("Error occured" + e.getMessage());
	     		}
	            m_blnProcessingStarted = false;
	            ctx.getLogger(getName()).log(MessageFormat.format(m_strNewState, new Object[] {new Integer(y), m_strStateNames[y]}), getName(), 0);
	            ctx.getLogger(getName()).log(MessageFormat.format(m_strEndProcess, new Object[] {new Integer(event.getEvent()), m_strEventNames[event.getEvent()]}), getName(), 0);
	
	            if (intOldState != y) stateChanged(intOldState);
	        }

            try
            {
                Thread.sleep(m_intDelay);
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
        }
    }
    
    /**
    *   zXX  . XX - ,   
    * @param p_intNumber   
    */
    protected void z(int p_intNumber) throws Exception
    {
    	ctx.getLogger(getName()).log(MessageFormat.format(m_strZ, new Object[] {new Integer(p_intNumber), m_strActionNames[p_intNumber]}), getName(), 1);
    	getClass().getDeclaredMethod("z" + p_intNumber, null).invoke(this, null);
    }
    
    /**
    *    xXX  . XX - ,   
    * @param p_intNumber   
    */
    protected boolean x(int p_intNumber) throws Exception
    {
    	boolean result = ((Boolean)getClass().getDeclaredMethod("x" + p_intNumber, null).invoke(this, null)).booleanValue();
    	
        String strValueName;
        strValueName = result ? m_strTrue: m_strFalse;
        ctx.getLogger(getName()).log(MessageFormat.format(m_strX, new Object[] {new Integer(p_intNumber), m_strVarNames[p_intNumber], strValueName}), getName(), 1);
    	return result;
    }

    /**
    *   .
    * @param p_Event     .
    */
    protected abstract void caseBlock(int p_Event) throws Exception;


    /**
    *   ,      .
    * @param p_intOldState   .
    */
    protected abstract void stateChanged(int p_intOldState);


    /**
    *    
    * @return   
    */
    protected String getCaller() throws Exception
    {
    	if (m_blnProcessingStarted == false)
    	{
    		throw new Exception("You can access this method only during event processing");
    	}
    	return m_strCaller;
    }
    
    /**
    *   .
    * @return  .
    */
    public String getName()
    {
        return m_strName;
    }
}