import java.util.*;
import java.applet.*;

/**
*  .    , 
*/
public class Context
{
    /**   .*/
    private Logger      m_logger = null;

    /**C .*/
    private Hashtable   m_hashAutomatas;

    /** .*/
    private Applet  m_appMain;     

    /**C  .*/
    public Vector m_busyAutomatas = new Vector();

    /** .*/
    public Hashtable m_hashFreeATS = new Hashtable();


    /**
    * .
    * @param  p_app   .
    */
    public Context(Applet p_app)
    {
        m_hashAutomatas = new Hashtable();
        m_appMain       = p_app;
    }

    
    /**
    *   ,  .
    * @param  p_strLoggerName   .     .
    * @return   {@link Logger}.
    */
    public Logger getLogger(String p_strLoggerName)
    {
        if (m_logger == null) {
            m_logger = new Logger(p_strLoggerName);
        }
        return m_logger;
    }

    /**
    *   ,  .
    * @return   {@link Logger}.
    */
    public Logger getLogger() { return getLogger(""); }

    /**
    *     .
    * @param p_automata  .
    */
    public void addAutomata(BaseAutomata p_automata)
    {
        if (m_hashAutomatas.containsKey(p_automata.getName()))
        {
            getLogger().log("Replace automata " + p_automata.getName(), "Context");
        }
        m_hashAutomatas.put(p_automata.getName(), p_automata);

        if (p_automata.getClass().getName() == "A1")
            m_hashFreeATS.put(p_automata.getName(), "free");

        getLogger().log("Add automata " + p_automata.getName(), "Context");
    }

    /**
    *     .
    * @param  .
    * @return    .
    */
    public BaseAutomata getAutomata(String p_strAutomataName)
    {
        return (BaseAutomata) m_hashAutomatas.get(p_strAutomataName);
    }


    /**
    *     .
    * @param p_strParameterName  .
    * @return .
    */
    public String getParameter(String p_strParameterName)
    {
        String strTmp = m_appMain.getParameter(p_strParameterName);
        return (strTmp == null) ? "#" + p_strParameterName + "#": strTmp;
    }

    /**
    *    .     {@link Context#getAutomata(String)}   .
    * @return    .
    */
    public String getFreeATS()
    {
        for (Enumeration e = m_hashFreeATS.keys(); e.hasMoreElements(); ) 
        {
            String name = (String)e.nextElement();

            if (((String)m_hashFreeATS.get(name)).equals("free"))
            {
                m_hashFreeATS.put(name, "busy");
                return name;
            }
        }
        return null;
    }   

    /**
    *  
    * @param p_strATSName  
    */
    public void occupyATS(String p_strATSName) throws Exception
    {
        String atsState = (String)m_hashFreeATS.get(p_strATSName);

        if ( (atsState == null) || (atsState == "free") )
        {
            m_hashFreeATS.put(p_strATSName, "busy");
        }
        else if (atsState == "busy")
        {
            m_hashFreeATS.put(p_strATSName, "very busy");
        }
        else if (atsState == "very busy")
        {
            throw new Exception("ATS already busy");
        }
    }
    
    /**
    *  .
    * @param p_strATSName  
    */
    public void setATSFree(String p_strATSName) throws Exception
    {
        String atsState = (String)m_hashFreeATS.get(p_strATSName);
        
        if ( (atsState == null) || (atsState == "free") )
        {
            throw new Exception("ATS already free");
        }
        else if (atsState == "busy")
        {
            m_hashFreeATS.put(p_strATSName, "free");
        }
        else if (atsState == "very busy")
        {
            m_hashFreeATS.put(p_strATSName, "busy");
        }
    }

}
