import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
/**
*  . <br><br>
*  :
* <ul>
*   <li>c "";</li>
*   <li> ;</li>
*   <li>;</li>
*   <li>  ;</li>
*   <li> "";</li>
*   <li> " ";</li>
*   <li> .</li>
* </ul>
*/
public class Phone extends Panel implements ActionListener, Runnable
{
    /** .*/
    private Context  ctx;

    //interface controls
    /**  .*/
    private Button[] m_btnDigits;
    /** "".*/
    private Button   m_btnReset;
    /** " ."*/
    private Button   m_btnReciever;
    /**.*/
    private Label    m_lblDisplay;
    /** .*/
    private Label    m_lblState;

    /** .*/
    private String   m_strAutomataName;
    /**   " ".*/
    private String   m_strRecieverUp;
    /**   " ".*/
    private String   m_strRecieverDown;
    
    /**   */
    private Thread   m_threadGo;
    
    /**   */
    private AudioClip m_audio;


    /**
    * .
    * @param p_strAutomataName  .
    * @param p_ctx  .
    */
    public Phone(String p_strAutomataName, Context p_ctx)
    {
        super(new BorderLayout(5, 5));

        ctx = p_ctx;
        m_strAutomataName = p_strAutomataName;

        m_strRecieverUp = ctx.getParameter("HangUp");
        m_strRecieverDown = ctx.getParameter("HangDown");

        initControls();
    }

    
    /**   .*/
    private void initControls()
    {
        setBackground(new Color(0, 0, 128));

        Label lblTelephone = new Label(ctx.getParameter("Telephone"));
        lblTelephone.setFont(new Font("Arial", Font.BOLD, 20));
        lblTelephone.setBackground(new Color(0, 0, 128));
        lblTelephone.setForeground(Color.white);
        lblTelephone.setAlignment(Label.CENTER);

        Label lblNumber = new Label(m_strAutomataName);
        lblNumber.setFont(new Font("Arial", Font.BOLD, 14));
        lblNumber.setBackground(new Color(0, 0, 128));
        lblNumber.setForeground(Color.white);
        lblNumber.setAlignment(Label.CENTER);

        m_lblDisplay = new Label("");
        m_lblDisplay.setBackground(new Color(255, 128, 64));
        m_lblDisplay.setForeground(Color.white);

        m_btnDigits = new Button[10];
        for(int i = 0; i < 10; i++) 
        {
            m_btnDigits[i] = new Button(i + "");
            m_btnDigits[i].setActionCommand("e1" + i);
            m_btnDigits[i].addActionListener(this);
        }

        m_btnReset = new Button("C");
        m_btnReset.setActionCommand("e4");
        m_btnReset.addActionListener(this);
                
        m_btnReciever = new Button(m_strRecieverUp);
        m_btnReciever.setActionCommand("e2");
        m_btnReciever.addActionListener(this);

        m_lblState = new Label("");
        m_lblState.setBackground(Color.lightGray);


        Panel pnlTitle    = new Panel(new BorderLayout(0, 0));
        Panel pnlDisplay  = new Panel(new BorderLayout(10, 10));
        Panel pnlButtons  = new Panel(new GridLayout(4, 3, 5, 5));
        Panel pnlReciever = new Panel();
        Panel pnlState    = new Panel(new GridLayout(1, 1));

        pnlTitle.add(lblTelephone, BorderLayout.CENTER);
        pnlTitle.add(lblNumber, BorderLayout.SOUTH);
        
        pnlDisplay.add(m_lblDisplay, BorderLayout.CENTER);

        for(int i = 1; i < 10; i++)
        {
            pnlButtons.add(m_btnDigits[i]);
        }

        pnlButtons.add(new Label("")); 
        pnlButtons.add(m_btnDigits[0]);
        pnlButtons.add(m_btnReset);

        pnlReciever.add(m_btnReciever);    

        pnlState.add(m_lblState);

        Panel tmp = new Panel(new BorderLayout(5, 5));
        tmp.add(pnlTitle, BorderLayout.NORTH);
        tmp.add(pnlDisplay, BorderLayout.SOUTH);
        add(tmp, BorderLayout.NORTH);

        add(pnlButtons, BorderLayout.CENTER);
        tmp = new Panel(new BorderLayout(5, 5));
        tmp.add(pnlReciever, BorderLayout.NORTH);
        tmp.add(pnlState, BorderLayout.CENTER);
        add(tmp, BorderLayout.SOUTH);

        add(new Label(" "), BorderLayout.EAST);
        add(new Label(" "), BorderLayout.WEST);
    }

    
    public void actionPerformed(ActionEvent e)
    {
        String strTmp = e.getActionCommand();

        if (strTmp == "e2")
        {
            A(2);
            return;
        }

        if (strTmp == "e3")
        {
            A(3);
            return;
        }

        if (strTmp == "e4")
        {
            A(4);
            return;
        }

        for (int i = 10; i < 20; i++)
        {
            if (strTmp.equals("e" + i))
            {
                A(i);
                return;
            }
        }
    }
    
    
    /**
    *    .
    * @param p_s .
    */
    public void displayAddString(String p_s)
    {
        if (m_lblDisplay.getText().length() + p_s.length() < 11)
            m_lblDisplay.setText(m_lblDisplay.getText() + p_s);
    }

    /**   .*/
    public void displayReset()
    {
        m_lblDisplay.setText("");
    }

    /**
    *        " ".
    * @param p_intState   
    * @param p_stateName  .
    * @param isRecieverUp   .
    */
    public void setState(int p_intState, String p_stateName, boolean isRecieverUp)
    {
        m_lblState.setText(p_stateName);
        if (isRecieverUp)
        {
            m_btnReciever.setLabel(m_strRecieverDown);
            m_btnReciever.setActionCommand("e3");
        } else
        {
            m_btnReciever.setLabel(m_strRecieverUp);
            m_btnReciever.setActionCommand("e2");
        }
        
        try
        {
            if (m_audio != null)
            {
                m_audio.stop();
                m_audio = null;
            }
                
            String strFileName = null;
            switch(p_intState)
            {
                case 7:
                    strFileName = "ring.mid";
                    break;
                case 5:
                    strFileName = "long.mid";
                    break;
                case 4:
                case 9:
                    strFileName = "short.mid";
                    break;
            }
            
            if (strFileName != null)
            {
                m_audio = Applet.newAudioClip(new URL("file:" + strFileName));
                m_audio.loop();
            }
        }
        catch(Exception e)
        {
            ctx.getLogger("").log("Mid files unavailable");
        }
        
        if (p_intState == 7)
        {
            m_threadGo = new Thread(this);
            m_threadGo.start();
        }
        else
        {
            m_threadGo = null;
        }
    }
    
    /**  */
    public void run()
    {
        Thread th = Thread.currentThread();
    
        m_lblDisplay.setBackground(new Color(0, 0, 0));
        m_lblDisplay.setText("            <<<>>>");
        
        boolean isNative = true;
        
        while (th == m_threadGo)
        {
            if (isNative)
            {
                m_lblDisplay.setBackground(new Color(255, 255, 255));
                isNative = false;
            }
            else
            {
                m_lblDisplay.setBackground(new Color(255, 128, 64));
                isNative = true;
            }
            
            try
            {
                Thread.sleep(200);
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
        }
        
        if (m_lblDisplay.getText() == "            <<<>>>")
            m_lblDisplay.setText("");
        m_lblDisplay.setBackground(new Color(255, 128, 64));
    }
    

    /**
    *   {@link A0}.
    * @param p_event .
    */
    private void A(int p_event)
    {
        ctx.getAutomata(m_strAutomataName).A(new BaseEvent(p_event, null));
    }
}